<!DOCTYPE html>
<html>
<head xmlns:th="http://www.thymeleaf.org">
<meta charset="ISO-8859-1">
<title>Code Mst Report</title>

<!-- CSS LIBRARY -->
<link rel="stylesheet" type="text/css" href="../../Content/dataTables/dataTables.bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="../../Content/dataTables/buttons.bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="../../Content/dataTables/select.bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="../../Content/dataTables/jquery.dataTables.min.css">
<link rel="stylesheet" type="text/css" href="../../Content/bootstrap/bootstrap.min.css">

<!-- JAVASCRIPT LIBRARY -->
<script type="text/javascript" src="../../Scripts/jquery-3.4.1.js"></script>
<script type="text/javascript" src="../../Scripts/jquery-ui.min.js"></script>
<script type="text/javascript" src="../../Scripts/datatables/jquery.dataTables.min.js"></script>
<script type="text/javascript" src="../../Scripts/dataTables/dataTables.buttons.min.js"></script>
<script type="text/javascript" src="../../Scripts/dataTables/dataTables.select.min.js"></script>
<script type="text/javascript" src="../../Scripts/dataTables/dataTables.bootstrap.min.js"></script>
<script type="text/javascript" src="../../Scripts/dataTables/buttons.bootstrap.min.js"></script>
</head>
<!-- <body style="background-image: url('../../Images/img/desk-1081708_1920.jpg');">
 -->
 
 <style type="text/css">
 	td {
		padding-right: 10px;
	}
	
	.highlight {
	    border: 1px solid red;
	    font-weight: bold;
	    font-size: 45px;
	    background-color: lightblue;
	}
	
	#listCodeMstTable tbody .selected {
	    background: #007bff;;
	    color: white;
	    font-weight: bold;
	}
	
	.sort-item {
		background-color: lightblue;
	}
 </style>
 
 <body style="background-color: #EFEFEF; " >
<!-- ----------------------- -->
<!--		 HEADER			 -->
<!-- ----------------------- -->
<!-- <th:block th:include="_header"></th:block>
 -->
 
<th:block th:include="_navbar"></th:block>
 
<div class="main" style="width: 1210px; margin: 0 auto; " >

	<!-- ------------- -->
	<!-- ADD COMPONENT -->
	<!-- ------------- -->
	<div id="add-comp" style=" margin: 0 auto; margin: 20px 0px 20px 0px;" >
		<form action="/codeMst/add" method="post" th:object="${codeMst}">
			<table>
				<tr>
					<td>コードタイプ (codeType)</td>
					<td>コード名称 (codeName)</td>
					<td>コード値 (codeValue)</td>
					<td>ソート順 (sortIndex)</td>
					<td>説明 (remarks)</td>
<!-- 					<td rowspan="2" ><button class="btn btn-primary" type="submit"> 追加(Insert) </button></td>
 -->				
 					<td></td>
 				</tr>
				<tr>
					<td><input type="text" name="codeType" th:field="*{codeType}" class="form-control"/></td>
					<td><input type="text" name="codeName" th:field="*{codeName}" class="form-control" /></td>
					<td><input type="text" name="codeValue" th:field="*{codeValue}" class="form-control" /></td>
					<td><input type="number" name="sortIndex" th:field="*{sortIndex}" class="form-control" /></td>
					<td><input type="text" name="remarks" th:field="*{remarks}" class="form-control" /></td>
					<td><button class="btn btn-primary" type="submit"> 追加(Insert) </button></td>
				</tr>
				<tr>
					<td th:if="${! #fields.hasErrors('codeType')}" style="color: red;" ></td>
					<td th:if="${#fields.hasErrors('codeType')}" th:errors="*{codeType}" style="color: red;" ></td>
					<td th:if="${! #fields.hasErrors('codeName')}" style="color: red;" ></td>
					<td th:if="${#fields.hasErrors('codeName')}" th:errors="*{codeName}" style="color: red;" ></td>
					<td th:if="${! #fields.hasErrors('codeValue')}" style="color: red;" ></td>
					<td th:if="${#fields.hasErrors('codeValue')}" th:errors="*{codeValue}" style="color: red;" ></td>
					<td th:if="${! #fields.hasErrors('sortIndex')}" style="color: red;" ></td>
					<td th:if="${#fields.hasErrors('sortIndex')}" th:errors="*{sortIndex}" style="color: red;" ></td>
					<td th:if="${! #fields.hasErrors('remarks')}" style="color: red;" ></td>
					<td th:if="${#fields.hasErrors('remarks')}" th:errors="*{remarks}" style="color: red;" ></td>
				</tr>
			</table>
		</form>
	</div>
	
	<!-- ---------------- -->
	<!-- SEARCH COMPONENT -->
	<!-- ---------------- -->
	<div id="search-comp" style=" margin: 0 auto; margin: 20px 0px 20px 0px;" >
		<form action="">
			<table>
				<tr>
					<td>コードタイプ (codeType)</td>
					<td>コード名称 (codeName)</td>
					<td>コード値 (codeValue)</td>
					<td>ソート順 (sortIndex)</td>
					<td>説明 (remarks)</td>
					<td></td>
					<!-- <td rowspan="2"><button class="btn btn-primary" type="button" id="search-btn">検索(Search)</button></td> -->
				</tr>
				<tr>
					<td><input type="text" name="codeType" id="codeType-s" class="form-control" /></td>
					<td><input type="text" name="codeName" id="codeName-s" class="form-control" /></td>
					<td><input type="text" name="codeValue" id="codeValue-s" class="form-control" /></td>
					<td><input type="number" name="sortIndex" id="sortIndex-s" class="form-control" /></td>
					<td><input type="text" name="remarks" id="remarks-s" class="form-control" /></td>
					<td><button class="btn btn-primary" type="button" id="search-btn">検索(Search)</button></td>
				</tr>
			</table>
		</form>
	</div>
	
	<!-- ------------------------------------ -->
	<!-- 			EDIT COMPONENT			  -->
	<!-- ------------------------------------ -->
	<div class="edit" id="edit-table" style="display: none; margin: 0 auto; margin: 20px 0px 20px 0px;" >
		<form>
			<table>
				<tr>
					<td>コードタイプ (codeType)</td>
					<td>コード名称 (codeName)</td>
					<td>コード値 (codeValue)</td>
					<td>ソート順 (sortIndex)</td>
					<td>説明 (remarks)</td>
					<!-- <td rowspan="2"><button id="edit-btn"  class="btn btn-primary">追加(Edit)</button></td> -->
					<td></td>
				</tr>
				<tr>
					<td><input type="text" name="codeType" id="codeType-e" class="form-control" /></td>
					<td><input type="text" name="codeName" id="codeName-e" class="form-control" readonly /></td>
					<td><input type="text" name="codeValue" id="codeValue-e" class="form-control" /></td>
					<td><input type="number" name="sortIndex" id="sortIndex-e" class="form-control" /></td>
					<td><input type="text" name="remarks" id="remarks-e" class="form-control" /></td>
					<td><button id="edit-btn"  class="btn btn-primary">追加(Edit)</button></td>
				</tr>
				<tr>
					<td id="codeType-er" style="color: red;"></td>
					<td id="codeName-er" style="color: red;" ></td>
					<td id="codeValue-er" style="color: red;" ></td>
					<td id="sortIndex-er" style="color: red;" ></td>
					<td id="remarks-er" style="color: red;" ></td>
				</tr>
			</table>
		</form>
	</div>
	
	<!-- ------------------------------------------- -->
	<!-- 				SHOW TABLE					 -->
	<!-- ------------------------------------------- -->
	<table id="listCodeMstTable"
		class="table table-striped table-bordered" style="width: 100%;">
		<thead>
			<tr>
				<td>コードタイプ (codeType)</td>
				<td>コード名称 (codeName)</td>
				<td>コード値 (codeValue)</td>
				<td>ソート順 (sortIndex)</td>
				<td>説明 (remarks)</td>
				<td>更新/削除 (edit/delete)</td>
			</tr>
		</thead>
	</table>
	<div style="width: 1210px; float: right; margin: 0 auto; /*margin-top: -30px*/; 
			margin-bottom: 30px; ">
		<button id="expand-btn" style="float: right; margin-left: 20px; margin-right: 10px;" class="btn btn-primary" >Expand</button>
		<button id="update-btn" style="float: right; " class="btn btn-primary" >Update</button>
	</div>

	</div>
</body>

<!-- ----------------------------------------------------------- -->
<!-- 				MY SCRIPT TO LOAD DATATABLES    			 -->
<!-- ----------------------------------------------------------- -->
<script th:inline="none">
	var listCodeMstTable;
	var selectedRow;
	var listNewPosition = [];
	
	/*************************************************************************************/
	/**								MY SCRIPT DOCUMENT READY				 			**/
	/*************************************************************************************/
	$(document).ready(function () {
		listCodeMstTable = $('#listCodeMstTable').DataTable ({
			"bDestroy": true,
			"processing": true,
			"retrieve": true,
			"sAjaxSource": "/codeMst/getAll",
			"sAjaxDataProp": "",
			"aoColumns": [
				{
					"mData": "codeType"
				},
				{
					"mData": "codeName"
				},
				{
					"mData": "codeValue"
				},
				{
					"mData": "sortIndex"
				},
				{
					"mData": "remarks"
				},
				{
					  data: null,
					  className: "center",
					  defaultContent: '<a style="text-decoration: none ;" class="editor_edit" href="#" >更新</a> / <a style="text-decoration: none ;" class="editor_remove" href="#" >削除</a>'
				}
			],
			select: true,
			scrollX: true,
			scrollY: true,
			autoWidth: true,
			searching: false,
			lengthChange: false,
			"order": [[ 3, "asc" ]]
			//paging: false
		});
		
		/*****************************************************/
		/**				MY SCRIPT TO SEARCH IN TABLE 		**/
		/*****************************************************/
		$('#search-btn').on('click', function () {
			var data = {
					'codeType': $('#codeType-s').val(), 
					'codeName': $('#codeName-s').val(),
					'codeValue': $('#codeValue-s').val(),
					'sortIndex': $('#sortIndex-s').val(),
					'remarks': $('#remarks-s').val()
			};
			
			console.log('a');
			
			$.ajax({
				url: window.location.origin + '/codeMst/findCodeMst',
				type: 'post',
				data: data,
				success: function (data) {
					listCodeMstTable.clear().rows.add(data).draw();
				}
			});
			
		});
		
		/*****************************************************/
		/**				MY SCRIPT TO EDIT IN TABLE 	   		**/
		/*****************************************************/
		$('#listCodeMstTable').on('click', 'a.editor_edit', function (e) {
			e.preventDefault();
			
			selectedRow = listCodeMstTable.row($(this).closest('tr'));
			var oldData = selectedRow.data();
			
			$('#edit-table').show();
			
			$('#id-e').val(oldData['iD']);
			$('#codeType-e').val(oldData['codeType']); 
			$('#codeName-e').val(oldData['codeName']);
			$('#codeValue-e').val(oldData['codeValue']);
			$('#sortIndex-e').val(oldData['sortIndex']);
			$('#remarks-e').val(oldData['remarks']);
			
			$('#edit-btn').on('click', function () {
				
				console.log(oldData);
								
				var codeMstOld = {
						'codeType': $('#codeType-e').val(),
						'codeName': $('#codeName-e').val(),
						'codeValue': $('#codeValue-e').val(),
						'sortIndex': $('#sortIndex-e').val(),
						'remarks': $('#remarks-e').val() 
				};
				var codeMstNew = {
				};
				
				codeMstNew['iD'] = oldData['iD'];
				codeMstNew['codeType'] = $('#codeType-e').val();
				codeMstNew['codeName'] = $('#codeName-e').val();
				codeMstNew['codeValue'] = $('#codeValue-e').val();
				codeMstNew['sortIndex'] = $('#sortIndex-e').val();
				codeMstNew['remarks'] = $('#remarks-e').val();
				
				var data = {  
					'codeMstOld': codeMstOld, 
					'codeMstNew': codeMstNew
				};
				
				// CONFIRM
				var confm = confirm ("Are you sure want to edit data: [ iD = " 
					+ data.codeMstNew['iD'] + ", codeName = " + data.codeMstNew['codeName'] + ", codeType = " + data.codeMstNew['codeType'] + ", codeValue = " 
					+ data.codeMstNew['codeValue'] + ", remarks = " + data.codeMstNew['remarks'] + ", sortIndex = " + data.codeMstNew['sortIndex'] + " ] ?");
				
				if (confm) {
					console.log(confm);
					
					$.ajax({
						url: window.location.origin + '/codeMst/edit',
						type: 'post',
						contentType: 'application/json',
						dataType: 'json',
						data: JSON.stringify(codeMstNew),
						cache: false,
						timeout: 5000,
						success: function (data) {
							selectedRow.data(data['result'][0]).draw();
							$('#edit-table').hide();
							return;
						},
						error: function (e) {
							$('#codeType-er').html('');
							$('#codeName-er').html('');
							$('#codeValue-er').html('');
							$('#sortIndex-er').html('');
							$('#remarks-er').html('');
							
							var data = JSON.parse(e.responseText);
							var msgs = data.msg;
							
							msgs = msgs.split(',');
							
							for (var i = 0; i < msgs.length; i++) {
								var msg = msgs[i];
								
								if (msg.indexOf('Code Type') >= 0 || msg.includes('Code Type') || msg.includes('codeType')) {
									$('#codeType-er').html(msg);
								} else if (msg.indexOf('Code Name') >= 0 || msg.includes('Code Name') || msg.includes('codeName')) {
									$('#codeName-er').html(msg);
								} else if (msg.indexOf('Code Value') >= 0 || msg.includes('Code Value') || msg.includes('codeValue')) {
									$('#codeValue-er').html(msg);
								} else if (msg.indexOf('Sort Index') >= 0 || msg.includes('Sort Index') || msg.includes('sortIndex')) {
									$('#sortIndex-er').html(msg);
								} else if (msg.indexOf('Remarks') >= 0 || msg.includes('Remarks') || msg.includes('remarks')) {
									$('#remarks-er').html(msg);
								}  
							}
						}
					});
				}
				
			});
		});
		
		/*****************************************************/
		/**				MY SCRIPT TO DELETE IN TABLE 		**/
		/*****************************************************/
		$('#listCodeMstTable').on('click', 'a.editor_remove', function (e) {
			e.preventDefault();
			
			selectedRow = listCodeMstTable.row ($(this).closest('tr'));
			var data = selectedRow.data();
			
			// CONFIRM
			var confm = confirm ("Are you sure want to delete data: [ iD = " 
				+ data['iD'] + ", codeName = " + data['codeName'] + ", codeType = " + data['codeType'] + ", codeValue = " 
				+ data['codeValue'] + ", remarks = " + data['remarks'] + ", sortIndex = " + data['sortIndex'] + " ] ?");
			
			if (confm) {
			
				$.ajax({
					url: window.location.origin + '/codeMst/delete',
					type: 'post',
					data: data,
					success: function (data) {
						selectedRow.remove().draw();
						console.log("Delete sc");
					}
				});
			}
		});
		
		$('#listCodeMstTable tbody').sortable({
			start: function (event, ui) {				
				// HIGH LIGHT
				//ui.item.toggleClass("highlight");
				
				// UPDATE LIST OLD POSITION ++ LIST NEW POSITION
				var length = $("#listCodeMstTable tbody tr").length - 1;
						
				if (listNewPosition.length != length) 
					listNewPosition = [];
				
				if (listNewPosition.length === 0) {
				
					for (var i = 0; i < length; i++) {
						listNewPosition.push(i);
					}
				} 
				
				$(ui.item).data("startindex", ui.item.index());
				
				// TEST
				console.log(ui.item.index());
				
				console.log(listNewPosition);
			},
			stop: function (event, ui) {
				// HIGH LIGHT
				//ui.item.toggleClass("highlight");
				
				var startIndex = $(ui.item).data("startindex");
				var newIndex = $(ui.item).index();
								
				// UPDATE LIST OLD POSITION ++ LIST NEW POSITION
				swap(listNewPosition, startIndex, newIndex);
				
				// TEST
				console.log(startIndex + "--->" + newIndex);
				
				console.log(listNewPosition);
			},
			placeholder: "highlight",
			forcePlaceholderSize: true,
			helper: fixWidthHelper
		}).disableSelection();;
		
		// UPDATE CURRENT PAGE AFTER SORTABLE
		$('#update-btn').on('click', function () {
			
			console.log("just click to update btn");
			
			var list = listCodeMstTable.rows({ page: 'current' }).data();
			
			list = $.makeArray(list);
			var position = listNewPosition.join();
			
			var currentPage = listCodeMstTable.page();
			var lengthOfEachPage = listCodeMstTable.page.info().length;
			
			$.ajax({
				url: window.location.origin + '/codeMst/updatePage',
				type: 'post',
				data: { "list": list, "currentPage": listCodeMstTable.page(), "start": listCodeMstTable.page.info().start,
					"lengthOfEachPage": listCodeMstTable.page.info().length, "end": listCodeMstTable.page.info().end, 
					"listNewPosition": position },
				success: function (data) {
					//listCodeMstTable.rows({ page: 'current' }).data(data).draw('page');
					
					//listCodeMstTable.rows({ page: 'current' }).remove().draw('page');
					//listCodeMstTable.rows({ page: 'current' }).add(data).draw('page');
					
					//if (data.length > 0) {
					//	listCodeMstTable.rows({ page: 'current' }).every(function (rowIdx, tableLoop, rowLoop) {
					//		listCodeMstTable.row(rowIdx).data(data[rowIdx]).draw('page');
					//	});
					//}
					
					if (data.length > 0) {
						
						//listCodeMstTable.clearPipeline().draw();
						
						//listCodeMstTable.rows({ page: 'current' }).eq(0).each( function ( index ) {
						//	listCodeMstTable.row(index).data(data[index]).draw();
						//});
						
						var beginIndex = currentPage * lengthOfEachPage;
						
						for (var index = 0; index < data.length; index++) {
							var ind = beginIndex + index;
							
							listCodeMstTable.row(ind).data(data[index]).draw();
						}
						
						listCodeMstTable.ajax.reload();
						//listCodeMstTable.order( [ 3, 'asc' ] ).draw();
						//listCodeMstTable.page(currentPage).draw('page');
					}
					
					listNewPosition = [];
				}
			});
			
		});
		
		/*****************************************************************/
		/**			    	MY SCRIPT EXPAND DATATABLES		 			**/
		/*****************************************************************/
		$("#expand-btn").on('click', function () {
			
			var lengthOfData = listCodeMstTable.data().length;
			var defaultLength = 10;
			var numberOfPage = listCodeMstTable.page.info().pages;
			
			listCodeMstTable.page.len( lengthOfData ).draw();
			
			if (numberOfPage > 1) {
				//$("#expand-btn").html('Expand');
				listCodeMstTable.page.len( lengthOfData ).draw();
				$("#expand-btn").html('Collapse');
				$('#listCodeMstTable').css({
					'display': 'block',
				    'height': '500px',
			    	'overflow-y': 'scroll'
				});
			} else {
				//$("#expand-btn").html('Collapse');
				listCodeMstTable.page.len( defaultLength ).draw();
				$("#expand-btn").html('Expand');
				$('#listCodeMstTable').removeAttr('style');
			}
			
		});
		
	});
	/*************************************************************************************/
	/**								MY SCRIPT END DOCUMENT READY		   	 			**/
	/*************************************************************************************/
	
	function swap(list, start, end) {
		
		if (start < end) {			
			var k = list[start];
			
			// PART 1
			for (var i = start; i < end; i++) {
				list[i] = list[i + 1];
			}
			
			// PART 2
			list[end] = k;
		} else {
			var k = list[start];

			// PART 1
			for (var i = start; i > end; i--) {
				list[i] = list[i - 1];
			}
			
			// PART 2
			list[end] = k;		
		}
		
	}
	
	function fixWidthHelper(e, ui) {
	    ui.children().each(function() {
	        $(this).width($(this).width());
	    });
	    return ui;
	}
</script>

</html>